#ifndef EXTRADATAPROVIDER_H
#define EXTRADATAPROVIDER_H

#include <processcore/process.h>

#include <QtPlugin>

class QString;
class QVariant;

namespace KSysGuard
{

class Q_DECL_EXPORT ExtraDataProvider
{
public:
    virtual ~ExtraDataProvider() = default;
    virtual Process::UpdateExtraData updateExtraDataFn() const = 0;
    virtual Process::DestroyExtraData destroyExtraDataFn() const = 0;
    virtual int columnCount() const = 0;
    virtual QString heading(int column) const = 0;
    virtual QVariant data(int role, int column, void *extraData) const = 0;
};

}

#define KSysGuard_ExtraDataProvider_iid "ru.rusbitech.ksysguard.ExtraDataProvider"
Q_DECLARE_INTERFACE(KSysGuard::ExtraDataProvider, KSysGuard_ExtraDataProvider_iid)

#endif
